package me.unurled.sacredrealms.sr.gui.recordings;

import static me.unurled.srcore.utils.Component.textComp;

import java.util.UUID;
import me.unurled.sacredrealms.sr.SR;
import me.unurled.sacredrealms.sr.components.cutscene.Cutscene;
import me.unurled.sacredrealms.sr.components.cutscene.CutsceneManager;
import me.unurled.sacredrealms.sr.components.cutscene.RecordingManager;
import me.unurled.srcore.api.Manager;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.persistence.PersistentDataType;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.item.AbstractItem;
import xyz.xenondevs.invui.item.Click;
import xyz.xenondevs.invui.item.ItemBuilder;
import xyz.xenondevs.invui.item.ItemProvider;

public class CutsceneItem extends AbstractItem {

  private static NamespacedKey ID = null;
  private final String name;
  private final UUID uuid;

  public CutsceneItem(String name, UUID uuid) {
    this.name = name;
    this.uuid = uuid;
    ID = new NamespacedKey(SR.getPlugin(), "cutscene_id");
  }

  @Override
  public @NotNull ItemProvider getItemProvider(@NotNull Player viewer) {
    ItemStack itemStack = new ItemStack(Material.PAPER);
    ItemMeta itemMeta = itemStack.getItemMeta();
    itemMeta.displayName(textComp(name));
    itemMeta.getPersistentDataContainer().set(ID, PersistentDataType.STRING, uuid.toString());
    itemStack.setItemMeta(itemMeta);

    return new ItemBuilder(itemStack);
  }

  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull Click click) {
    // get uuid
    String uuid =
        click
            .getCursor()
            .getItemMeta()
            .getPersistentDataContainer()
            .get(ID, PersistentDataType.STRING);

    Cutscene cutscene =
        Manager.getInstance(CutsceneManager.class).findByUUID(UUID.fromString(uuid));

    if (cutscene == null) {
      player.sendMessage(textComp("<red>Unexpected error."));
      return;
    }
    if (clickType.isLeftClick()) {
      Manager.getInstance(RecordingManager.class).startRecording(cutscene, player);
    }
  }
}
